#include <windows.h>
#include "NScrFunc.h"
#include "NScrExec_dll.h"

static HWND m_hWnd;
static int m_nWidth;
static int m_nHeight;

static void ShowWindow(COLORREF crColor);
static void HideWindow(void);
static COLORREF GetColorRef(char *s);
static int Asc2Int(char c);


BOOL APIENTRY DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	switch (fdwReason) {
	case DLL_PROCESS_ATTACH:
		NScrFunc();
		NScrGetWindowSize(&m_nWidth, &m_nHeight);
		m_hWnd = NULL;
		break;

	case DLL_PROCESS_DETACH:
		break;

	case DLL_THREAD_ATTACH:
		break;

	case DLL_THREAD_DETACH:
		break;
	}

	return TRUE;
}

BOOL NScrPlugInMain (HINSTANCE hInstance, HWND hWnd, char *lpParam, int *nRet_int, char *cRet_str)
{
	switch (*lpParam) {
	case '#':
		ShowWindow(GetColorRef(lpParam + 1));
		break;

	default:
		HideWindow();
		break;
	}


	return FALSE;
}

static void ShowWindow(COLORREF crColor)
{
	HDC hDc;
	HBRUSH hBrush;
	HBRUSH hOldBrush;


	if (m_hWnd == NULL) {
		m_hWnd = CreateWindow(TEXT("STATIC"),
		                      "",
		                      SS_SIMPLE | WS_CHILD | WS_VISIBLE,
		                      0, 0,
		                      m_nWidth, m_nHeight,
		                      NScrGetWindow(),
		                      (HMENU)1234,//NULL,
		                      GetModuleHandle(NULL),
		                      NULL);
		if (m_hWnd == NULL)
			return;
	}
	ShowWindow(m_hWnd, SW_SHOW);
	SetWindowPos(m_hWnd,
	             HWND_TOPMOST,
	             0, 0,
	             0, 0,
	             SWP_NOMOVE | SWP_NOSIZE);

	hDc = GetDC(m_hWnd);
	hBrush = CreateSolidBrush(crColor);
	hOldBrush = (HBRUSH)SelectObject(hDc, hBrush);
	PatBlt(hDc, 0, 0, m_nWidth, m_nHeight, PATCOPY);
	SelectObject(hDc, hOldBrush);
	DeleteObject(hBrush);
	ReleaseDC(m_hWnd, hDc);
}

static void HideWindow(void)
{
	if (m_hWnd == NULL)
		return;

	ShowWindow(m_hWnd, SW_HIDE);
}

static COLORREF GetColorRef(char *s)
{
	int r,g,b;
	int i;


	for (i = 0, r = 0;i < 2 && *s;i++, s++) {
		r = r * 16 + Asc2Int(*s);
	}

	for (i = 0, g = 0;i < 2 && *s;i++, s++) {
		g = g * 16 + Asc2Int(*s);
	}

	for (i = 0, b = 0;i < 2 && *s;i++, s++) {
		b = b * 16 + Asc2Int(*s);
	}

	return RGB(r, g, b);
}

static int Asc2Int(char c)
{
	if (c >= '0' && c <= '9') {
		return c - '0';

	} else if (c >= 'a' && c <= 'f') {
		return c - 'a' + 10;

	} else if (c >= 'A' && c <= 'F') {
		return c - 'A' + 10;

	} else {
		return 0;

	}
}

